#include <iostream> 
template <typename T>
class Vecteur {
 private:
  int taille;
  T *elements;
 public:
  Vecteur(int n); // ctor ordinaire
  // Vecteur(Vecteur v); // incorrect
  Vecteur(const Vecteur &v); // ctor de copie, utilise l'objet d'origine (donc sa référence)
  Vecteur &operator=(const Vecteur &v); // operateur affectation
  //  void resize(int n);
  T &operator[](int i);
  ~Vecteur();
};

template <typename T>
Vecteur<T>::Vecteur(int n) {
  taille = n;
  elements = new T[taille];
  for (int i=0; i<taille; i++) { elements[i] = 0; }
}

template <typename T>
T &Vecteur<T>::operator[](int i) {
  if (i<0 || i>=taille) {
    std::cerr << "oups indice=" << i << " tableau de taille " << taille << std::endl;
    exit(1);
  }
  return elements[i];
}

template <typename T>
Vecteur<T>::~Vecteur() {
  delete [] elements;
}

template <typename T>
Vecteur<T> &Vecteur<T>::operator=(const Vecteur<T> &v) {
  if (this==&v) {
    return *this; // auto affectation
  }
  delete elements; // détruire l'ancienne resource
  taille = v.taille;
  elements = new T[taille]; // en créer une de la bonne taille
  for (int i=0; i<taille; i++) { // copie des elements
    elements[i] = v.elements[i];
  }
  return *this;
}

template <typename T>
Vecteur<T>::Vecteur(const Vecteur<T> &v) { // chacun a sa propre resource (copie de la resource d'origine)
  taille = v.taille;
  elements = new T[taille];
  for (int i=0; i<v.taille; i++) {
    elements[i] = v.elements[i];
  }
}
