#include "VecteurInt.h"
#include <iostream>

VecteurInt::VecteurInt(int n) {
  taille = n;
  elements = new int[taille];
  for (int i=0; i<taille; i++) { elements[i] = 0; }
}

int &VecteurInt::operator[](int i) {
  if (i<0 || i>=taille) {
    std::cerr << "oups indice=" << i << " tableau de taille " << taille << std::endl;
    exit(1);
  }
  return elements[i];
}

VecteurInt::~VecteurInt() {
  delete [] elements;
}

VecteurInt &VecteurInt::operator=(const VecteurInt &v) {
  if (this==&v) {
    return *this; // auto affectation
  }
  delete elements; // détruire l'ancienne resource
  taille = v.taille;
  elements = new int[taille]; // en créer une de la bonne taille
  for (int i=0; i<taille; i++) { // copie des elements
    elements[i] = v.elements[i];
  }
  return *this;
}

VecteurInt::VecteurInt(const VecteurInt &v) { // chacun a sa propre resource (copie de la resource d'origine)
  taille = v.taille;
  elements = new int[taille];
  for (int i=0; i<v.taille; i++) {
    elements[i] = v.elements[i];
  }
}
